import ReactExports from 'react';
import { shallow } from 'zustand/vanilla/shallow';

const { useRef } = ReactExports;
function useShallow(selector) {
  const prev = useRef();
  return (state) => {
    const next = selector(state);
    return shallow(prev.current, next) ? prev.current : (
      // It might not work with React Compiler
      // eslint-disable-next-line react-compiler/react-compiler
      prev.current = next
    );
  };
}

export { useShallow };
